{-# LANGUAGE DuplicateRecordFields #-}
module CFG.Graph
       ( graphify
       , cfg
       ) where

import Data.Graph
import Data.Text (Text)
import Control.Comonad
import Data.Maybe

import CFG.Types

cfg :: Function () -> Function CFG
cfg = extend graphify

graphify :: Function () -> CFG
graphify function = CFG g ver2node key2vert entry
  where (g, ver2node, key2vert) = graphFromEdges $ graphList function
        entry = fromJust $ key2vert (funEntryNode function)

graphList :: Function () -> [(Block, Text, [Text])]
graphList = map iter . funBlocks
  where iter b = (b, blkName (b :: Block), blkSuccessors b)
