{-# LANGUAGE OverloadedStrings, DuplicateRecordFields #-}
module CFG.SanitizeSpec (spec) where

import qualified Data.Text as T
import Data.Text.Arbitrary ()
import Test.Hspec
import Test.QuickCheck
import Data.Char

import CFG.Sanitize

spec :: Spec
spec = describe "sanitize" $ do
  it "strips invalid characters"
    containsOnlyValidCharacters

  it "it strips leading underscores"
    doesntBeginWithUnderscore

containsOnlyValidCharacters :: Property
containsOnlyValidCharacters = property $ \txt ->
  T.all isValid (sanitize txt)

  where
    isValid x = x == '_' || isAlphaNum x

doesntBeginWithUnderscore :: Property
doesntBeginWithUnderscore = property $ \txt ->
  case T.uncons (sanitize txt) of
    Nothing -> True
    Just (first,_) -> first /= '_'
